from petri.pnml import PNMLParser, PNMLEnzymeParser
from petri.align import Align

import numpy

import os, pickle

# Existen los ficheros para almacenar la info?
if not os.path.isfile("compscore.pkl"):
    # Creamos el fichero
    f = open("compscore.pkl", "wb")
    pickle.dump({}, f)
    f.close()
if not os.path.isfile("enzscore.pkl"):
    # Creamos el fichero
    f = open("enzscore.pkl", "wb")
    pickle.dump({}, f)
    f.close()

import sys
from exceptions import IOError

if len(sys.argv) != 4:
    print "Expected more argumentes: python scores.py <Path KEGG ID> <FILE1> <FILE2>\n"
    print "<Path KEGG ID> should be the ID of generic pathway in KEGG, for example 00010 if you are computing Glycolisis\n"
    sys.exit(0)

path = sys.argv[1]
bicho1 = sys.argv[2]
bicho2 = sys.argv[3]

try:
    PNE = PNMLEnzymeParser("ec/" + path + "/ec" + path + ".xml")
except IOError:
    print "Path KEGG ID '" + str(path) + "' seems that doesn't exist. Or it's not availabe in our 'ec' folder"
    sys.exit(0)

try:
    datos1 = PNMLParser(bicho1)
    datos1.enz_db = PNE
except IOError:
    print "It seems that '" + bicho1 +"' doesn't exist."
    sys.exit(0)

try:
    datos2 = PNMLParser(bicho2)
    datos2.enz_db = PNE
except IOError:
    print "It seems that '" + bicho2 +"' doesn't exist."
    sys.exit(0)

A = Align(datos1, datos2)

out = open("align-path.txt", "w+")

B = A.path_align()
for b in B:
    r1 = B[b][0]
    r2 = B[b][1]
    out.write("------ " + str(B[b][2]) + " -----\n")
    for i in xrange(len(r1)):
        out.write(r1[i] + "\t" + r2[i] + "\n")
    out.write("\n\n")

out.close()

out = open("align-react.txt", "w+")

B = A.reaction_align()
for b in B:
    if B[b][0] is not None:
        out.write(b + "\t" + B[b][0] + "\t" + str(B[b][-1]) + "\n")
    else:
        out.write(b + "\t---\t0\n")
for c in A.route1.reactions():
    if c not in B:
        out.write(c + "\t---\t0\n")
out.close()

score = A.final_score()
motif = A.motiff()

out = open("motif.txt", "w+")
print score[1]
for i in motif:
    out.write(i + "\n")
out.close()